#!/usr/bin/python
# coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Linux面板
# editor: mufei(ypdh@qq.com tel:15712150708)
'''
牧飞 _ __ ___   ___   ___  / _| ___(_)
| '_ ` _ \ / _ \ / _ \| |_ / _ \ |
| | | | | | (_) | (_) |  _|  __/ |
|_| |_| |_|\___/ \___/|_|  \___|_|
'''
#+--------------------------------------------------------------------
#|   宝塔第三方应用开发 mfngxwaf
#+---

import os
import re
import sys
import time
import shutil
import subprocess


#添加包引用位置并引用公共包
sys.path.append("/www/server/panel/class/")
import public
import sqlite3


installPth = "/www/server/panel/install"
nginxsh = os.path.join(installPth, "nginx.sh")
wfwafsh = os.path.join(installPth, "mfngxwaf.sh")

def addToTask():
    "添加到消息队列"
    conn = sqlite3.connect("/www/server/panel/data/default.db")
    cur = conn.cursor()
    execstr = "python /www/server/panel/plugin/mfngxwaf/install.py"
    sql = "insert into tasks(id,name,type,status,addtime,execstr)values(?,?,?,?,?,?)"
    cur.execute(sql, [None,'install[mfngxwaf-1.2]','execshell','0',time.strftime('%Y-%m-%d %H:%M:%S'),execstr])
    conn.commit()
    cur.close()
    conn.close()
            
    isTask = '/tmp/panelTask.pl'
    public.writeFile(isTask,'True')

if '--task' in sys.argv:
    addToTask()
    sys.exit(0)


def copy2(src, dst):
    shutil.copy(src, dst)
    os.popen('chmod 744 '+dst)

def wget_py_ngx():
    url  = 'https://codeload.github.com/arut/nginx-python-module/zip/master'
    zip = '/www/server/nginx/nginx-python-module.zip'
    print(os.popen('wget %s -O %s'%(url,zip)).read())
    print(os.popen('unzip -o %s -d /www/server/nginx'%zip).read())
    if os.path.isdir('/www/server/nginx/nginx-python-module-master'):
        shutil.move("/www/server/nginx/nginx-python-module-master","/www/server/nginx/nginx-python-module")
        
pluginPth="/www/server/panel/plugin/mfngxwaf"
def init_conf():
    pluginCfgPth = os.path.join(pluginPth, 'conf')
    #检测mfwaf配置文件是否完整，mfngxwaf.py使用最新版本
    wafngxPath = "/www/server/nginx/mfwaf"
    if not os.path.isdir(wafngxPath):os.makedirs(wafngxPath)
    os.popen('chown www.www '+wafngxPath)
    if not os.path.isdir(wafngxPath+'/conf'): os.mkdir(wafngxPath+'/conf')
    os.popen('chown www.www '+wafngxPath+'/conf')
    
    for t in ('captcha.txt','ipblacks.txt','ipwhites.txt','ipcdns.txt','ipzhizhu.txt','uriblacks.txt','uablacks.txt'):
        pth = os.path.join(wafngxPath, 'conf', t)
        if not os.path.isfile(pth):
            src = os.path.join(pluginCfgPth, '_'+t)
            copy2(src, pth)
            
    src = os.path.join(pluginPth, "mfngxwaf.py") #复制mfwaf【如同lua】的py文件到nginx的配置环境
    copy2(src, "/www/server/nginx/mfwaf/mfngxwaf.py")
    
    copy2('/www/server/panel/plugin/mfngxwaf/bt-2.ttf', "/www/server/nginx/mfwaf/bt-2.ttf")
    copy2('/www/server/panel/plugin/mfngxwaf/vilidate.py', "/www/server/nginx/mfwaf/vilidate.py")
    if os.path.isdir("/www/server/nginx/conf"):
        copy2('/www/server/panel/plugin/mfngxwaf/mfngxwaf.conf', "/www/server/nginx/conf/mfngxwaf.conf")
        copy2('/www/server/panel/plugin/mfngxwaf/captcha.png', "/www/server/nginx/mfwaf/conf/captcha.png")


#创建/www/server/panel/install/mfngxwaf.sh(nginx.sh的修改版)
#目的是添加nginx-python-module模块信息到nginx.sh文件修改版nginx.sh中
if os.path.isfile('/www/server/nginx/sbin/nginx'): 
    with open(nginxsh) as f:  #兼容python install.py 安装
        installTxt = f.read()
else:
    installTxt = ''  
    

#读取【nginx -V】配置信息   nginxInfo=os.popen('`/www/server/nginx/sbin/nginx -V >%s` '%tmpPth).read()
ngxVersion="tengine"
if installTxt:
    tmpPth = os.path.join('./','tmp.mfwaf.txt')
    with open(tmpPth,'w') as f:
        pub = subprocess.Popen(['/www/server/nginx/sbin/nginx','-V'], stdin=f, stdout=f, stderr=f)
        while pub.poll() is None: time.sleep(0.1)
        pub.communicate()
    nginxInfo=open(tmpPth).read()
    os.remove(tmpPth)
    _ngxVer = re.search('nginx\sversion:\s+nginx/(.+)', nginxInfo) #获取ngx版本
    if _ngxVer:
        ngxVersion=_ngxVer.group(1).strip().lower()
        if ngxVersion.count('.')>1:
            ngxVersions = ngxVersion.split('.')
            ngxVersion = "%s.%s"%(ngxVersions[0],ngxVersions[1])
    #print(ngxVersion)
    if "nginx-python-module" in nginxInfo:
        #检测nginx-python-module模块是否存在【nginx -V】中,存在退出
        print("nginx-python-module is OK")
        print(nginxInfo)
        init_conf()
        sys.exit(0)
    


def re_installTxt():
    
    p="(?P<k>[.]/configure\s.*)(\$\{ENABLE_LUA\})(?P<v>\s.*--add-module=)"
    s="${ENABLE_LUA} --add-module=/www/server/panel/plugin/mfngxwaf/nginx-python-module"
    def func(m):
        dms = m.groupdict()
        k = dms['k']
        v = dms['v']
        return k+s+v
    if re.search(p, installTxt):
        wfwafngxTxt = re.sub(p, func, installTxt)
        open(wfwafsh,'w').write(wfwafngxTxt)
        return 1
    else:
        copy2('/www/server/panel/plugin/mfngxwaf/mfngxwaf.sh', "/www/server/panel/install/mfngxwaf.sh")
    return 0

re_shTxt = re_installTxt()
print(re_shTxt) 
#使用ngx的install安装nginx-python-module模块
print(os.popen('chmod +x /www/server/panel/install/mfngxwaf.sh').read())
pub = subprocess.Popen([wfwafsh, 'update', ngxVersion]) #mfngxwaf.sh(nginx.sh的修改版)安装
while pub.poll() is None: time.sleep(0.1)
pub.communicate()

init_conf()
copy2('/www/server/panel/plugin/mfngxwaf/mfngxwaf.conf', "/www/server/nginx/conf/mfngxwaf.conf")
copy2('/www/server/panel/plugin/mfngxwaf/captcha.png', "/www/server/nginx/mfwaf/conf/captcha.png")
sys.exit(0) #退出


#rpm安装方法
#print(os.popen('yum -y install rpm-build').read())



def pythonModuleMake():
    try:
        import psutil
        cpu_count = psutil.cpu_count() or 1
    except:
        cpu_count = 1
    configure=re.search(r'configure\s+arguments\:\s+(.*)',nginxInfo)
    if configure:
        arguments = configure.group(1).split(' --') 
        arguments = ['--'+e for e in arguments]
        arguments.append('--add-module=/www/server/panel/plugin/mfngxwaf/nginx-python-module')
        cmd = ['./configure']+arguments
        pub = subprocess.Popen(cmd, cwd="/www/server/nginx/src")
        while pub.poll() is None: time.sleep(0.1)
        pub.communicate()

        pub = subprocess.Popen(['make', '-j%s'%cpu_count], cwd="/www/server/nginx/src")
        while pub.poll() is None: time.sleep(0.1)
        pub.communicate()

        print(os.popen('/etc/init.d/nginx stop').read())
        print(os.popen('cp -f /www/server/nginx/sbin/nginx /www/server/nginx/sbin/nginx.mfwaf.bak').read())
        print(os.popen('cp -rfp /www/server/nginx/src/objs/nginx /www/server/nginx/sbin/nginx').read())
        print(os.popen('/etc/init.d/nginx start').read())
        print(os.popen('/www/server/nginx/sbin/nginx -V'))


#pythonModuleMake()


#if os.path.isdir('/www/server/nginx/src') and os.path.isfile('/www/server/nginx/src/configure'):
#    pythonModuleMake()
#else:
#    print(os.popen('chmod +x /www/server/panel/install/mfngxwaf.sh').read())
#    pub = subprocess.Popen([wfwafsh, 'update'])
#    while pub.poll() is None: time.sleep(0.1)
#    pub.communicate()
    
            








