#!/usr/bin/python
# coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Linux面板
# editor: mufei(ypdh@qq.com tel:15712150708)
'''
牧飞 _ __ ___   ___   ___  / _| ___(_)
| '_ ` _ \ / _ \ / _ \| |_ / _ \ |
| | | | | | (_) | (_) |  _|  __/ |
|_| |_| |_|\___/ \___/|_|  \___|_|
'''
#+--------------------------------------------------------------------
#|   宝塔第三方应用开发 mfngxwaf
#+--------------------------------------------------------------------

__all__ = ['mfngxwaf_main']

import sys,os,json,re,time
import requests

try:
    from urllib.parse import unquote
except:
    from urllib import unquote

#设置运行目录
basedir = os.path.abspath(os.path.dirname(__file__))
plugin_path = basedir


    

if __name__ != '__main__':
    #添加包引用位置并引用公共包
    sys.path.append("class/")
    import public
    from BTPanel import cache,session

    #设置缓存(超时10秒) cache.set('key',value,10)
    #获取缓存 cache.get('key')
    #删除缓存 cache.delete('key')

    #设置session:  session['key'] = value
    #获取session:  value = session['key']
    #删除session:  del(session['key'])

from IPy import IP

int_ip = lambda x: '.'.join([str(x/(256**i)%256) for i in range(3,-1,-1)])
ip_int = lambda x:sum([256**j*int(i) for j,i in enumerate(x.split('.')[::-1])])
def get_ips(ip1,ip2):
    f=open('ips.txt','w')
    ip1_num = ip_int(ip1)
    ip2_num = ip_int(ip2)
    for i in range(ip1_num,ip2_num+1):
        f.write(str(int_ip(i))+'\n')
#get_ips('192.168.0.0','192.168.255.255')

def checkIP(ip, one=0, d=None):
    if one:
        p = r"^(\d+)[.](\d+)[.](\d+)[.](\d+)$"
    else:
        p = r"^(\d+)[.](\d+)[.](\d+)[.](\d+)\/(\d+)?$"
    rs = re.findall(p, ip.strip())
    if rs:
        rs = [int(e or 0) for e in rs[0]]
        if rs[0]>255 or rs[1]>255 or rs[2]>255 or rs[3]>255:
            return ip+" :error"
        elif rs[0]<1 or rs[1]<0 or rs[2]<0 or rs[3]<0:
            return ip+" :error"
        elif len(rs)==4 or not rs[4]:
            pass
        elif rs[4]<16 or rs[4]>32:
            return ip+" :error in /(16-32)"
    else:
        return ip+" :error ip"
    if d is not None: 
        pass
        
 
def checkTxt(path, isip=0, isre=0):
    if not os.path.isfile(path):
        return ''
    txt = open(path).read()
    txt = re.sub('<!--[\s\S]*?-->', ' ', txt)
    L = []
    for line in txt.split('\n'):
        s = line.split('#')[0].strip()
        if s: L.append(s)
    if isip:
        for s in L:
            if s[0]=='(': s=s[1:-1]
            if '|' in s:
                ss = s.split('|')
            else:
                ss = [s]
            for e in ss:
                e = e.strip()
                if '-' in e:
                    e1,e2 = e.split('-', 1)
                    err = checkIP(e1.strip(), 1)
                    if err: return err
                    err = checkIP(e2.strip(), 1)
                    if err: return err
                if '/' in e:
                    err = checkIP(e)
                    if err: return err
                    try:
                        IP(e)
                    except :
                        return e+" :error in /(16-32)"
                else:
                    err = checkIP(e, 1)
                    if err: return err
    elif isre:
        for s in L:
            try:
                m = re.search(s,'')
            except:
                return s+" in error python-re"
            
        
            
            


class mfngxwaf_main:
    __plugin_path = plugin_path
    __config = None
    __mfwafPath = "/www/server/nginx/mfwaf"
    

    #构造方法
    def  __init__(self):
        ""
        self.__config = self.__get_config() or {'cc':{}}


    def check_txts(self, args):
        for t in ('ipblacks.txt','ipwhites.txt','ipcdns.txt','ipzhizhu.txt'):
            pth = os.path.join(self.__mfwafPath, 'conf',t)
            R = checkTxt(pth, isip=1)
            if R:
                return {"msg":t+" ERR: "+R,"status":0}
        for t in ('uriblacks.txt','uablacks.txt'):
            pth = os.path.join(self.__mfwafPath, 'conf',t)
            R = checkTxt(pth, isre=1)
            if R:
                return {"msg":t+" ERR: "+R,"status":0}
        
        return {"msg":"左侧名单检测OK","status":1}


    def waf_reload(self, args):
        try:
            rs = requests.get("http://127.0.0.1/mfwaf-reload").json()
        except:
            msg = "配置不存在或未开启mfWaf防火墙<br>请检查nginx配置(/www/server/nginx/conf/nginx.conf)是否存在python_include和python_access,填写请看论坛信息"
            rs = {'status':0, 'msg':msg}
        if rs.get('status'):
            rs['msg'] = "操作成功"
        return rs


    
    def save_conf(self, args):
        r1 = int(args.r1.strip() or '0')
        r2 = int(args.r2.strip() or '0')
        r3 = int(args.r3.strip() or '0')
        r4 = int(args.r4.strip() or '0')
        r5 = int(args.r5.strip() or '0')
        r6 = int(args.r6.strip() or '0')
        r7 = int(args.r7.strip() or '0')
        r8 = int(args.r8.strip() or '0')
        a1 = args.a1.strip() or ''
        b1 = int(args.b1) if "b1" in args else 0
        err = None
        if   0<r2<r1:
            err = {"msg":"规则2的值应该大于规则1","status":0}
        elif 0<r4<r3:
            err = {"msg":"规则4的值应该大于规则3","status":0}
        elif 0<r8<r7:
            err = {"msg":"规则8的值应该大于规则7","status":0}
        elif 0<r7<r1:
            err = {"msg":"规则7的值应该大于规则1","status":0}
        elif 0<r8<r2:
            err = {"msg":"规则8的值应该大于规则2","status":0}
        if err:
            return err
        
        d = {'r1':r1,
             'r2':r2, 'r3':r3, 'r4':r4,'r5':r5,'r6':r6,'r7':r7,'r8':r8,
             'a1':a1,
             'b1':b1
             }
        self.__set_config('cc',d)

        return {"msg":"CC防御设置保存成功","status":1}
    
    
        
    def index(self, args):
        return {'conf':self.__config}
        
        

   
    


    def __get_config(self,key=None,force=False):
        if not self.__config or force:
            config_file = self.__mfwafPath + '/'+ 'config.json'
            if not os.path.exists(config_file): return None
            f_body = public.ReadFile(config_file)
            if not f_body: return None
            self.__config = json.loads(f_body)
            
        if key:
            if key in self.__config: return self.__config[key]
            return None
        
        return self.__config


    def __set_config(self,key=None,value=None):
        if not self.__config: self.__config = {'cc':{}} 
        self.__config[key] = value
            
        config_file = self.__mfwafPath +'/'+ 'config.json'
        public.WriteFile(config_file,json.dumps(self.__config))
        
        return True

    






        
        
    
    
        
    

